#!/usr/bin/env python
# -*- coding: UTF-8 -*-
""" script d'affichage des variables eole (utilisé par ParseDico)
"""
from creole import parsedico
import os,sys
try:
    conf_file = sys.argv[1]
except:
    conf_file = None

if conf_file != None:
    # lecture des valeurs dans le fichier spécifié
    if os.path.isfile(conf_file):
        from ConfigParser import ConfigParser
        c = ConfigParser()
        files = c.read(conf_file)
        for var in c.sections():
            print '%s="%s"' % (var, " ".join(eval(c.get(var,"val"))))
    else:
        sys.exit(1)
else:
    val_dict = parsedico.parse_dico()
    for var, val in val_dict.items():
        if type(val) == list:
            print '%s="%s"' % (var, " ".join(val))
        else:
            print '%s="%s"' % (var, val)

sys.exit(0)
