# -*- coding: utf-8 -*-
"""
fichier de configuration pour créole

"""
import os
from os.path import isdir

KERNEL_FILE = '/etc/sysconfig/eole/noyau'
REBOOT_FILE = '/var/run/reboot-required'
# fixons le mode debug à True s'il s'agit un checkout subversion
if isdir("./.svn"):
    debug = True
else:
    debug = False

# nom long du fichier de rapport d'instanciation (nombre de fichiers instanciés...)
if not debug: logfile = '/var/log/creole.log'
if debug: logfile = '/dev/null'

charset = 'UTF8'

# chemin par defaut des templates, fichier config.eol, etc 
defaults = '/etc/eole/'

# chemin du répertoire source des fichiers templates
if not debug: templatedir = '/etc/eole/template'
if debug: templatedir = os.path.join(defaults,'template')

modif_dir = os.path.join(defaults,'modif')
distrib_dir = os.path.join(defaults,'distrib')
patch_dir = os.path.join(defaults,'patch')

# chemin pour les fichiers de données
datadir = '/usr/share/creole'

# repertoire du ou des dictionnaires xml creole
eoledirs = ['/etc/eole/dicos/local', '/etc/eole/dicos/', '/etc/eole/dicos/variante']

# template et cibles pour les services actifs
tserv = '/etc/eole/template/services'
fserv = '/etc/sysconfig/eole/services'

# fichier descriptif du module
f_version = os.path.join(defaults, 'version')

def log(type_action, etat, msg, date=''):
    from zephir.lib_zephir import log
    log(type_action, etat, msg, date)

try:
    from zephir.zephir_conf.zephir_conf import id_serveur
    zephir_actif = True
except:
    zephir_actif = False
